#include "double.h"
#include "aspen_devel.h"


#define	NUM_THREADS		192
#define	SPLIT_LOOP		1	/* meaningless in this kernel */
#define	LOOP_RANGE_ARRAY	1

#if GPU_ARCH == Tesla
	#define	USE_VOLATILE	1
	#define	USE_TEXTURE	1
	#define	USE_RESTRICT	0
	#define	USE_LDG		0
#else
#if GPU_ARCH == Fermi
	#define	USE_VOLATILE	1
	#define	USE_TEXTURE	1
	#define	USE_RESTRICT	0
	#define	USE_LDG		0
#else
#if GPU_ARCH == Kepler
	#define	USE_VOLATILE	1
	#define	USE_TEXTURE	0
	#define	USE_RESTRICT	1
	#define	USE_LDG		0
#else
#if GPU_ARCH == Kepler2
	#define	USE_VOLATILE	1
	#define	USE_TEXTURE	0
	#define	USE_RESTRICT	0
	#define	USE_LDG		1
#else
#if GPU_ARCH == Maxwell
	#define	USE_VOLATILE	1
	#define	USE_TEXTURE	0
	#define	USE_RESTRICT	0
	#define	USE_LDG		1
#else
#if GPU_ARCH == Maxwell2
	#define	USE_VOLATILE	1
	#define	USE_TEXTURE	0
	#define	USE_RESTRICT	0
	#define	USE_LDG		1
#else
	error !!
#endif // Maxwell2
#endif // Maxwell
#endif // Kepler2
#endif // Kepler
#endif // Fermi
#endif // Tesla

#include "aspen_devel_postdef.h"

#if USE_TEXTURE
	DEF_TEXTURE( texture_X, X );
#endif

#define	SUMUP_PREFIX		_NAME_1PARAMS_(DSYMVU,GPU_PREFIX)
#define	DSYMVu_STUB		_NAME_1PARAMS_(DSYMVu_LARGE,GPU_PREFIX)


#include "../tuning/CURRENT_GPU"


#if CURRENT_GPU==GPU_ARCH
	#include "../template/sumup_1Dx2_template.incl"
	#include "../template/symv_upper_atomic_template.incl"
#endif


extern "C" void
API(DSYMVu_STUB) ( const int blk,
         const int n, const scalar_t * a, const int lda,
         const scalar_t * x, scalar_t * y,
         const scalar_t alpha, const scalar_t beta )
{

// y = alpha * A * x + beta * y
// y(1:n1)
// x(1:n2)

#if CURRENT_GPU==GPU_ARCH
      int BLK = blk;
	#include "../tuning/param-dsymvu.h"
	#include "../tuning/dsymv-upper-auto.h"
#else
	fprintf( stderr,
		"Caution, ASPEN is tuned up for %s.\n",
		ASPEN_GPU_Names(CURRENT_GPU) );
#endif

}

