#!/bin/bash


DO_MATLAB ()
{

	echo "S=[ 0 " > cc$ID.m
	echo "1 " >> cc$ID.m
	awk ' \
		BEGIN { \
			line = 0; \
		} \
		{ \
			line++; \
			if ( line <= 1 )next; \
			if ( $1 > 0 ) print; \
		} \
	' IN-a--$ID >> cc$ID.m
	echo "];" >> cc$ID.m

	awk '/N=/{ print $2" "$5; }' log-$ID > log-RANK$ID
	CY=`tail log-$ID | awk '/CYCLE=/{ print $2; }'`


	cat << EOS_M >> cc$ID.m
CY=$CY;

[M,c]=size(S);
N=S(M)-S(1)+1;

EtE = sparse(N,N);
for j=1:M
        k=S(j)-S(1)+1;
        EtE(k,k)=1;
end

D = sparse(N,N);

if 1 == 0

for j=2:N-1

        n = j-1;

        nx = rem( n-1, CY ) + 1;
        ny = floor( (n-1)/ CY ) + 1;
        PY = floor( (N-1-1)/ CY ) + 1;

        if 1 < nx && nx < CY
        if 1 < ny && ny < PY
                if j-CY >= 1 && j+CY <= N
                                     D(j,j-CY)= 1;
                        D(j,j-1)= 1; D(j,j   )=-4; D(j,j+1)= 1;
                                     D(j,j+CY)= 1;
                else
                if j-CY >= 1
                                     D(j,j-CY)= 1;
                        D(j,j-1)= 1; D(j,j   )=-3; D(j,j+1)= 1;
		else
                if j+CY <= N
                        D(j,j-1)= 1; D(j,j   )=-3; D(j,j+1)= 1;
                                     D(j,j+CY)= 1;
		else
                        D(j,j-1)= 1; D(j,j   )=-2; D(j,j+1)= 1;
                end
                end
                end
        end
        end
        if ny == 1
        if 1 < nx && nx < CY
                if j+CY <= N
                        D(j,j-1)= 1; D(j,j   )= -3; D(j,j+1)= 1;
                                     D(j,j+CY)=  1;
		else
                        D(j,j-1)= 1; D(j,j   )= -2; D(j,j+1)= 1;
                end
        end
        end
	if ny == PY
        if 1 < nx && nx < CY
                if j-CY >= 1
                                     D(j,j-CY)=  1;
                        D(j,j-1)= 1; D(j,j   )= -3; D(j,j+1)= 1;
		else
                        D(j,j-1)= 1; D(j,j   )= -2; D(j,j+1)= 1;
                end
        end
        end
        if nx == 1
        if 1 < ny && ny < PY
                if j+CY <= N
                        D(j,j-CY)= 1; D(j,j  )= -3; D(j,j+CY)= 1;
                                      D(j,j+1)=  1;
		else
                        D(j,j-CY)= 1; D(j,j  )= -2;
                                      D(j,j+1)=  1;
                end
        end
        end
	if nx == CY
        if 1 < ny && ny < PY
                if j+CY <= N
                                      D(j,j-1)=  1;
                        D(j,j-CY)= 1; D(j,j  )= -3; D(j,j+CY)= 1;
		else
                                      D(j,j-1)=  1;
                        D(j,j-CY)= 1; D(j,j  )= -2;
                end
        end
        end

end

else

for j=2:N-1
	if rem( S(1)+j-1, CY ) > 1
        	D(j,j-1) = 1; D(j,j)=-2; D(j,j+1)= 1;
	end
end

end

% DtD=N*N*D'*D;
DtD=M*CY*CY*D'*D;

AA=EtE+DtD;

y=[ 0 
0
EOS_M

	awk '{ print $2 }' log-RANK$ID >> cc$ID.m

	cat << EOS_MM >> cc$ID.m
];
yy=zeros(N,1);
ii=zeros(N,1);
for j=1:M
        s = S(j)-S(1)+1;
        yy(s) = y(j);
end
for j=1:N
        ii(j) = j+S(1)-1;
end

yyN=yy(N);
yy=yy/yyN;
z=(AA\yy)*yyN;

[ii,z]
EOS_MM

        octave cc$ID.m
}


ID_PAT=`ls IN-a--* | awk '{ gsub(/IN\-a\-\-/," "); printf("%s ", $0); }'`

for ID in \
	$ID_PAT 
do

	echo 'Fitting kernel'$ID

	\touch mat_mat.$ID
	\rm mat_mat.$ID
	DO_MATLAB 1> mat_mat.$ID 2> /dev/null
	awk ' \
		BEGIN { \
			flag = 0; \
		} \
		/ans/ { \
			flag=1; next; \
		} \
		/[0-9]/ { \
			if ( flag ) { \
				if ( $2 < 0 ) $2 = 0; \
				printf("%6d %f\n", $1, $2); \
			} \
		} \
	' mat_mat.$ID > mat.$ID

done


