#!/bin/sh

do_touch_header()
{
	if [ ! -e $1 ]; then
		cp tuning-old/$MACHINE_DIR/$1 .
	fi
}

cd ../src; make get_dev_info; cd ../tuning

../src/get_dev_info $ASPEN_GPU_ID > DEV_INFO

DEVICE=`awk '/DEV/{print $2}' DEV_INFO`

MACHINE_DIR=
if [ -e tuning-old/$DEVICE ]; then
	MACHINE_DIR=$DEVICE
	echo 'The configuration files tuned for '$DEVICE' are adopted.'
else
	echo 'The default configuration files are adopted.'
fi

for header in \
	dgemvn_opt4.h \
	dgemvn-auto2.h \
	sgemvn_opt4.h \
	sgemvn-auto2.h \
	dgemvt-at-opt.c \
	sgemvt-at-opt.c \
	dsymv-upper-auto.h \
	dsymv-upper-auto2.h \
	param-dsymvu.h \
	ssymv-upper-auto.h \
	ssymv-upper-auto2.h \
	param-ssymvu.h \
	dsymv-lower-auto.h \
	dsymv-lower-auto2.h \
	param-dsymvl.h \
	ssymv-lower-auto.h \
	ssymv-lower-auto2.h \
	param-ssymvl.h
do
	do_touch_header $header
done


