#if 0
<--/****************************************
Automatic Performance Tuning for SGEMV -T
2015年  1月 12日 月曜日 15:31:21 JST
Host on gauss.aics27.riken.jp
Device is GeForce-GTX-580
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="gauss.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-580";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(16)
#endif
#if !defined(scalar_t)
#define scalar_t	float
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_SGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

#define	KERNEL_4	1
#define	KERNEL_18	1
#define	KERNEL_19	1
#define	KERNEL_7	1
#define	KERNEL_8	1
#define	KERNEL_10	1
#define	KERNEL_11	1
#define	KERNEL_1	1
#define	KERNEL_15	1
#define	KERNEL_2	1
#define	KERNEL_3	1
#define	KERNEL_16	1

if ( n >= 1 && n < 175 ) {
	BLK = 15;
} else
if ( n >= 175 && n < 573 ) {
	BLK = 11;
} else
if ( n >= 573 && n < 1024 ) {
	BLK = 7;
} else
if ( n >= 1024 && n < 1152 ) {
	BLK = 3;
} else
if ( n >= 1152 && n < 1265 ) {
	BLK = 16;
} else
if ( n >= 1265 && n < 1536 ) {
	BLK = 15;
} else
if ( n >= 1536 && n < 2048 ) {
	BLK = 4;
} else
if ( n >= 2048 && n < 2304 ) {
	BLK = 3;
} else
if ( n >= 2304 && n < 3072 ) {
	BLK = 10;
} else
if ( n >= 3072 && n < 3250 ) {
	BLK = 3;
} else
if ( n >= 3250 && n < 3328 ) {
	BLK = 1;
} else
if ( n >= 3328 && n < 3456 ) {
	BLK = 3;
} else
if ( n >= 3456 && n < 3584 ) {
	BLK = 2;
} else
if ( n >= 3584 && n < 3600 ) {
	BLK = 19;
} else
if ( n >= 3600 && n < 3638 ) {
	BLK = 11;
} else
if ( n >= 3638 && n < 3840 ) {
	BLK = 1;
} else
if ( n >= 3840 && n < 4096 ) {
	BLK = 7;
} else
if ( n >= 4096 && n < 4160 ) {
	BLK = 18;
} else
if ( n >= 4160 && n < 4352 ) {
	BLK = 1;
} else
if ( n >= 4352 && n < 4353 ) {
	BLK = 19;
} else
if ( n >= 4353 && n < 4480 ) {
	BLK = 18;
} else
if ( n >= 4480 && n < 4864 ) {
	BLK = 1;
} else
if ( n >= 4864 && n < 5120 ) {
	BLK = 7;
} else
if ( n >= 5120 && n < 5152 ) {
	BLK = 19;
} else
if ( n >= 5152 && n < 5376 ) {
	BLK = 1;
} else
if ( n >= 5376 && n < 5440 ) {
	BLK = 18;
} else
if ( n >= 5440 && n < 5632 ) {
	BLK = 1;
} else
if ( n >= 5632 && n < 5636 ) {
	BLK = 8;
} else
if ( n >= 5636 && n < 5760 ) {
	BLK = 18;
} else
if ( n >= 5760 && n < 5888 ) {
	BLK = 1;
} else
if ( n >= 5888 && n < 6020 ) {
	BLK = 8;
} else
if ( n >= 6020 && n < 6080 ) {
	BLK = 18;
} else
if ( n >= 6080 && n < 6144 ) {
	BLK = 1;
} else
if ( n >= 6144 && n < 18057 ) {
	BLK = 8;
} else
if ( n >= 18057 && n < 100000000 ) {
	BLK = 8;
}

#if 1
	int ii=BLK;
        #define SGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
                GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
                ( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		SGEMVT_KERNEL_ ( 224 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		SGEMVT_KERNEL_ ( 256 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		SGEMVT_KERNEL_ ( 96 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		SGEMVT_KERNEL_ ( 64 , 3 , 4, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		SGEMVT_KERNEL_ ( 32 , 4 , 4, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		SGEMVT_KERNEL_ ( 128 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		SGEMVT_KERNEL_ ( 128 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		SGEMVT_KERNEL_ ( 64 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		SGEMVT_KERNEL_ ( 256 , 1 , 5, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		SGEMVT_KERNEL_ ( 64 , 3 , 2, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		SGEMVT_KERNEL_ ( 32 , 4 , 8, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		SGEMVT_KERNEL_ ( 96 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		SGEMVT_KERNEL_ ( 224 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		SGEMVT_KERNEL_ ( 128 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		SGEMVT_KERNEL_ ( 192 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		SGEMVT_KERNEL_ ( 32 , 3 , 4, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		SGEMVT_KERNEL_ ( 64 , 2 , 6, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		SGEMVT_KERNEL_ ( 64 , 4 , 4, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		SGEMVT_KERNEL_ ( 224 , 1 , 5, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		SGEMVT_KERNEL_ ( 192 , 1 , 5, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

