#if 0
<--/****************************************
Automatic Performance Tuning for DGEMV -T
2015年  1月 13日 火曜日 22:17:53 JST
Host on gauss.aics27.riken.jp
Device is GeForce-GTX-980
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="gauss.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-980";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(16)
#endif
#if !defined(scalar_t)
#define scalar_t	double
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_DGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

#define	KERNEL_17	1
#define	KERNEL_18	1
#define	KERNEL_5	1
#define	KERNEL_6	1
#define	KERNEL_19	1
#define	KERNEL_7	1
#define	KERNEL_8	1
#define	KERNEL_13	1
#define	KERNEL_2	1
#define	KERNEL_15	1
#define	KERNEL_16	1
#define	KERNEL_3	1

if ( n >= 1 && n < 464 ) {
	BLK = 16;
} else
if ( n >= 464 && n < 531 ) {
	BLK = 7;
} else
if ( n >= 531 && n < 1374 ) {
	BLK = 3;
} else
if ( n >= 1374 && n < 1920 ) {
	BLK = 16;
} else
if ( n >= 1920 && n < 2016 ) {
	BLK = 7;
} else
if ( n >= 2016 && n < 2048 ) {
	BLK = 3;
} else
if ( n >= 2048 && n < 2240 ) {
	BLK = 6;
} else
if ( n >= 2240 && n < 2304 ) {
	BLK = 18;
} else
if ( n >= 2304 && n < 2389 ) {
	BLK = 13;
} else
if ( n >= 2389 && n < 2560 ) {
	BLK = 6;
} else
if ( n >= 2560 && n < 2832 ) {
	BLK = 13;
} else
if ( n >= 2832 && n < 2880 ) {
	BLK = 6;
} else
if ( n >= 2880 && n < 3808 ) {
	BLK = 13;
} else
if ( n >= 3808 && n < 3840 ) {
	BLK = 6;
} else
if ( n >= 3840 && n < 3943 ) {
	BLK = 2;
} else
if ( n >= 3943 && n < 4032 ) {
	BLK = 8;
} else
if ( n >= 4032 && n < 4089 ) {
	BLK = 2;
} else
if ( n >= 4089 && n < 4160 ) {
	BLK = 6;
} else
if ( n >= 4160 && n < 4224 ) {
	BLK = 8;
} else
if ( n >= 4224 && n < 4362 ) {
	BLK = 2;
} else
if ( n >= 4362 && n < 4384 ) {
	BLK = 8;
} else
if ( n >= 4384 && n < 4416 ) {
	BLK = 6;
} else
if ( n >= 4416 && n < 4571 ) {
	BLK = 2;
} else
if ( n >= 4571 && n < 4608 ) {
	BLK = 8;
} else
if ( n >= 4608 && n < 4740 ) {
	BLK = 2;
} else
if ( n >= 4740 && n < 4800 ) {
	BLK = 6;
} else
if ( n >= 4800 && n < 5543 ) {
	BLK = 2;
} else
if ( n >= 5543 && n < 5568 ) {
	BLK = 5;
} else
if ( n >= 5568 && n < 5613 ) {
	BLK = 15;
} else
if ( n >= 5613 && n < 5664 ) {
	BLK = 19;
} else
if ( n >= 5664 && n < 5760 ) {
	BLK = 17;
} else
if ( n >= 5760 && n < 5834 ) {
	BLK = 15;
} else
if ( n >= 5834 && n < 5835 ) {
	BLK = 19;
} else
if ( n >= 5835 && n < 5952 ) {
	BLK = 17;
} else
if ( n >= 5952 && n < 6028 ) {
	BLK = 15;
} else
if ( n >= 6028 && n < 6144 ) {
	BLK = 17;
} else
if ( n >= 6144 && n < 6221 ) {
	BLK = 15;
} else
if ( n >= 6221 && n < 6336 ) {
	BLK = 17;
} else
if ( n >= 6336 && n < 6414 ) {
	BLK = 15;
} else
if ( n >= 6414 && n < 6528 ) {
	BLK = 17;
} else
if ( n >= 6528 && n < 6606 ) {
	BLK = 15;
} else
if ( n >= 6606 && n < 6720 ) {
	BLK = 17;
} else
if ( n >= 6720 && n < 6798 ) {
	BLK = 15;
} else
if ( n >= 6798 && n < 6912 ) {
	BLK = 17;
} else
if ( n >= 6912 && n < 6990 ) {
	BLK = 15;
} else
if ( n >= 6990 && n < 7104 ) {
	BLK = 17;
} else
if ( n >= 7104 && n < 7181 ) {
	BLK = 15;
} else
if ( n >= 7181 && n < 7296 ) {
	BLK = 17;
} else
if ( n >= 7296 && n < 7372 ) {
	BLK = 15;
} else
if ( n >= 7372 && n < 7488 ) {
	BLK = 17;
} else
if ( n >= 7488 && n < 7562 ) {
	BLK = 15;
} else
if ( n >= 7562 && n < 7680 ) {
	BLK = 17;
} else
if ( n >= 7680 && n < 7753 ) {
	BLK = 15;
} else
if ( n >= 7753 && n < 7872 ) {
	BLK = 17;
} else
if ( n >= 7872 && n < 7943 ) {
	BLK = 15;
} else
if ( n >= 7943 && n < 8064 ) {
	BLK = 17;
} else
if ( n >= 8064 && n < 8133 ) {
	BLK = 15;
} else
if ( n >= 8133 && n < 8256 ) {
	BLK = 17;
} else
if ( n >= 8256 && n < 8322 ) {
	BLK = 15;
} else
if ( n >= 8322 && n < 8448 ) {
	BLK = 17;
} else
if ( n >= 8448 && n < 8512 ) {
	BLK = 15;
} else
if ( n >= 8512 && n < 8640 ) {
	BLK = 17;
} else
if ( n >= 8640 && n < 8701 ) {
	BLK = 15;
} else
if ( n >= 8701 && n < 8832 ) {
	BLK = 17;
} else
if ( n >= 8832 && n < 8890 ) {
	BLK = 15;
} else
if ( n >= 8890 && n < 9024 ) {
	BLK = 17;
} else
if ( n >= 9024 && n < 9079 ) {
	BLK = 15;
} else
if ( n >= 9079 && n < 9216 ) {
	BLK = 17;
} else
if ( n >= 9216 && n < 9268 ) {
	BLK = 15;
} else
if ( n >= 9268 && n < 9408 ) {
	BLK = 17;
} else
if ( n >= 9408 && n < 9456 ) {
	BLK = 15;
} else
if ( n >= 9456 && n < 9600 ) {
	BLK = 17;
} else
if ( n >= 9600 && n < 9645 ) {
	BLK = 15;
} else
if ( n >= 9645 && n < 9792 ) {
	BLK = 17;
} else
if ( n >= 9792 && n < 9833 ) {
	BLK = 15;
} else
if ( n >= 9833 && n < 9984 ) {
	BLK = 17;
} else
if ( n >= 9984 && n < 10022 ) {
	BLK = 15;
} else
if ( n >= 10022 && n < 10176 ) {
	BLK = 17;
} else
if ( n >= 10176 && n < 10210 ) {
	BLK = 15;
} else
if ( n >= 10210 && n < 20852 ) {
	BLK = 17;
} else
if ( n >= 20852 && n < 100000000 ) {
	BLK = 17;
}

#if 1
	int ii=BLK;
#define DGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
		GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
		( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		DGEMVT_KERNEL_ ( 384 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		DGEMVT_KERNEL_ ( 128 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		DGEMVT_KERNEL_ ( 320 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		DGEMVT_KERNEL_ ( 32 , 4 , 2, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		DGEMVT_KERNEL_ ( 128 , 2 , 2, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		DGEMVT_KERNEL_ ( 352 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		DGEMVT_KERNEL_ ( 192 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		DGEMVT_KERNEL_ ( 32 , 3 , 2, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		DGEMVT_KERNEL_ ( 288 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		DGEMVT_KERNEL_ ( 160 , 2 , 2, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		DGEMVT_KERNEL_ ( 96 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		DGEMVT_KERNEL_ ( 32 , 6 , 2, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		DGEMVT_KERNEL_ ( 16 , 16 , 2, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		DGEMVT_KERNEL_ ( 16 , 17 , 2, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		DGEMVT_KERNEL_ ( 256 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		DGEMVT_KERNEL_ ( 384 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		DGEMVT_KERNEL_ ( 32 , 5 , 2, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		DGEMVT_KERNEL_ ( 320 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		DGEMVT_KERNEL_ ( 160 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		DGEMVT_KERNEL_ ( 352 , 1 , 3, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

