#if 0
<--/****************************************
Automatic Performance Tuning for SGEMV -T
2015年  1月 14日 水曜日 03:33:00 JST
Host on gauss.aics27.riken.jp
Device is GeForce-GTX-980
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="gauss.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-980";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(16)
#endif
#if !defined(scalar_t)
#define scalar_t	float
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_SGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

#define	KERNEL_4	1
#define	KERNEL_5	1
#define	KERNEL_19	1
#define	KERNEL_8	1
#define	KERNEL_9	1
#define	KERNEL_10	1
#define	KERNEL_11	1
#define	KERNEL_12	1
#define	KERNEL_13	1
#define	KERNEL_2	1
#define	KERNEL_3	1

if ( n >= 1 && n < 325 ) {
	BLK = 13;
} else
if ( n >= 325 && n < 576 ) {
	BLK = 5;
} else
if ( n >= 576 && n < 585 ) {
	BLK = 11;
} else
if ( n >= 585 && n < 778 ) {
	BLK = 8;
} else
if ( n >= 778 && n < 1024 ) {
	BLK = 4;
} else
if ( n >= 1024 && n < 1152 ) {
	BLK = 5;
} else
if ( n >= 1152 && n < 1280 ) {
	BLK = 12;
} else
if ( n >= 1280 && n < 1350 ) {
	BLK = 8;
} else
if ( n >= 1350 && n < 1536 ) {
	BLK = 4;
} else
if ( n >= 1536 && n < 1728 ) {
	BLK = 5;
} else
if ( n >= 1728 && n < 2048 ) {
	BLK = 13;
} else
if ( n >= 2048 && n < 2201 ) {
	BLK = 2;
} else
if ( n >= 2201 && n < 2304 ) {
	BLK = 5;
} else
if ( n >= 2304 && n < 2459 ) {
	BLK = 2;
} else
if ( n >= 2459 && n < 2560 ) {
	BLK = 10;
} else
if ( n >= 2560 && n < 2826 ) {
	BLK = 2;
} else
if ( n >= 2826 && n < 2880 ) {
	BLK = 5;
} else
if ( n >= 2880 && n < 4352 ) {
	BLK = 2;
} else
if ( n >= 4352 && n < 4400 ) {
	BLK = 3;
} else
if ( n >= 4400 && n < 4607 ) {
	BLK = 2;
} else
if ( n >= 4607 && n < 4608 ) {
	BLK = 9;
} else
if ( n >= 4608 && n < 4688 ) {
	BLK = 3;
} else
if ( n >= 4688 && n < 4864 ) {
	BLK = 2;
} else
if ( n >= 4864 && n < 4977 ) {
	BLK = 3;
} else
if ( n >= 4977 && n < 5120 ) {
	BLK = 2;
} else
if ( n >= 5120 && n < 5265 ) {
	BLK = 3;
} else
if ( n >= 5265 && n < 5376 ) {
	BLK = 2;
} else
if ( n >= 5376 && n < 5554 ) {
	BLK = 3;
} else
if ( n >= 5554 && n < 5632 ) {
	BLK = 2;
} else
if ( n >= 5632 && n < 5843 ) {
	BLK = 3;
} else
if ( n >= 5843 && n < 5888 ) {
	BLK = 2;
} else
if ( n >= 5888 && n < 10189 ) {
	BLK = 3;
} else
if ( n >= 10189 && n < 10240 ) {
	BLK = 19;
} else
if ( n >= 10240 && n < 10422 ) {
	BLK = 3;
} else
if ( n >= 10422 && n < 10496 ) {
	BLK = 19;
} else
if ( n >= 10496 && n < 10656 ) {
	BLK = 3;
} else
if ( n >= 10656 && n < 10752 ) {
	BLK = 19;
} else
if ( n >= 10752 && n < 10890 ) {
	BLK = 3;
} else
if ( n >= 10890 && n < 11008 ) {
	BLK = 19;
} else
if ( n >= 11008 && n < 11124 ) {
	BLK = 3;
} else
if ( n >= 11124 && n < 11264 ) {
	BLK = 19;
} else
if ( n >= 11264 && n < 11358 ) {
	BLK = 3;
} else
if ( n >= 11358 && n < 11520 ) {
	BLK = 19;
} else
if ( n >= 11520 && n < 11593 ) {
	BLK = 3;
} else
if ( n >= 11593 && n < 11776 ) {
	BLK = 19;
} else
if ( n >= 11776 && n < 11828 ) {
	BLK = 3;
} else
if ( n >= 11828 && n < 29490 ) {
	BLK = 19;
} else
if ( n >= 29490 && n < 100000000 ) {
	BLK = 19;
}

#if 1
	int ii=BLK;
        #define SGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
                GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
                ( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		SGEMVT_KERNEL_ ( 320 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		SGEMVT_KERNEL_ ( 384 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		SGEMVT_KERNEL_ ( 384 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		SGEMVT_KERNEL_ ( 352 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		SGEMVT_KERNEL_ ( 192 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		SGEMVT_KERNEL_ ( 160 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		SGEMVT_KERNEL_ ( 320 , 1 , 8, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		SGEMVT_KERNEL_ ( 320 , 1 , 6, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		SGEMVT_KERNEL_ ( 256 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		SGEMVT_KERNEL_ ( 384 , 1 , 6, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		SGEMVT_KERNEL_ ( 64 , 2 , 8, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		SGEMVT_KERNEL_ ( 128 , 1 , 8, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		SGEMVT_KERNEL_ ( 64 , 5 , 4, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		SGEMVT_KERNEL_ ( 32 , 4 , 2, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		SGEMVT_KERNEL_ ( 160 , 2 , 8, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		SGEMVT_KERNEL_ ( 32 , 3 , 2, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		SGEMVT_KERNEL_ ( 32 , 4 , 8, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		SGEMVT_KERNEL_ ( 224 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		SGEMVT_KERNEL_ ( 384 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		SGEMVT_KERNEL_ ( 352 , 1 , 3, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

